class SharedCode extends Object;


static function bool CopyProperties_Actor(Actor Src, Actor Dest) {
/******************************************************************************
Returns TRUE if properties were copied successfully, FALSE otherwise.
******************************************************************************/
local int i;

	if (Src == None || Dest == None)
	{
		warn("CopyProperties_Actor: both parameters must be not None; src=" $ src $ ", dest=" $ dest);
		return False;
	}

	Dest.InitialState = Src.InitialState;
	Dest.Group = Src.Group;

	// Execution and timer variables.
	Dest.LifeSpan = Src.LifeSpan;

	// Net variables.
	Dest.RemoteRole = Src.RemoteRole;
	//Dest.Role = Src.Role;

	// Animation variables.
	Dest.AnimSequence = Src.AnimSequence;
	Dest.AnimFrame = Src.AnimFrame;
	Dest.AnimRate = Src.AnimRate;
	Dest.LODBias = Src.LODBias;

	Dest.bCanTeleport = Src.bCanTeleport;
	Dest.bOwnerNoSee = Src.bOwnerNoSee;
	Dest.bOnlyOwnerSee = Src.bOnlyOwnerSee;
	Dest.bAlwaysRelevant = Src.bAlwaysRelevant;
	Dest.bHighDetail = Src.bHighDetail;
	Dest.bStasis = Src.bStasis;
	Dest.bForceStasis = Src.bForceStasis;
	Dest.Velocity = Src.Velocity;
	Dest.OddsOfAppearing = Src.OddsOfAppearing;
	Dest.bHiddenEd = Src.bHiddenEd;
	Dest.bDirectional = Src.bDirectional;
	Dest.bEdShouldSnap = Src.bEdShouldSnap;
	Dest.bDifficulty0 = Src.bDifficulty0;
	Dest.bDifficulty1 = Src.bDifficulty1;
	Dest.bDifficulty2 = Src.bDifficulty2;
	Dest.bDifficulty3 = Src.bDifficulty3;
	Dest.bSinglePlayer = Src.bSinglePlayer;
	Dest.bNet = Src.bNet;
	Dest.bNetSpecial = Src.bNetSpecial;

	// Scriptable.
	Dest.tag = Src.tag;
	Dest.event = Src.event;
	Dest.AmbientSound = Src.AmbientSound;
	Dest.AttachTag = Src.AttachTag;

	Dest.LightType = Src.LightType;
	Dest.LightEffect = Src.LightEffect;
	Dest.LightBrightness = Src.LightBrightness;
	Dest.LightHue = Src.LightHue;
	Dest.LightSaturation = Src.LightSaturation;
	Dest.LightRadius = Src.LightRadius;
	Dest.LightPeriod = Src.LightPeriod;
	Dest.LightPhase = Src.LightPhase;
	Dest.LightSaturation = Src.LightSaturation;
	Dest.LightCone = Src.LightCone;
	Dest.VolumeBrightness = Src.VolumeBrightness;
	Dest.VolumeRadius = Src.VolumeRadius;
	Dest.VolumeFog = Src.VolumeFog;

	Dest.bSpecialLit = Src.bSpecialLit;
	Dest.bActorShadows = Src.bActorShadows;
	Dest.bCorona = Src.bCorona;
	Dest.bLensFlare = Src.bLensFlare;

	Dest.bBounce = Src.bBounce;
	Dest.bFixedRotationDir = Src.bFixedRotationDir;
	Dest.bRotateToDesired = Src.bRotateToDesired;
	Dest.Mass = Src.Mass;
	Dest.Buoyancy = Src.Buoyancy;
	Dest.RotationRate = Src.RotationRate;
	Dest.DesiredRotation = Src.DesiredRotation;

	Dest.NetPriority = Src.NetPriority;
	Dest.NetUpdateFrequency = Src.NetUpdateFrequency;

	// Display properties:
	Dest.RenderIteratorClass = Src.RenderIteratorClass;
	Dest.DrawType = Src.DrawType;
	Dest.Style = Src.Style;
	Dest.bShadowCast = Src.bShadowCast;
	Dest.bGameRelevant = Src.bGameRelevant;
	Dest.bIsSecretGoal = Src.bIsSecretGoal;
	Dest.bIsKillGoal = Src.bIsKillGoal;
	Dest.bIsItemGoal = Src.bIsItemGoal;
	Dest.bCollideWhenPlacing = Src.bCollideWhenPlacing;
	Dest.bTravel = Src.bTravel;
	Dest.bMovable = Src.bMovable;
	for (i = 0; i < 8; i++)
		if (Src.MultiSkins[i] != None) // set only, if mappers original has a value - replacement could have a MultiSkin intentionally
			Dest.MultiSkins[i] = Src.MultiSkins[i];
	Dest.bHidden = Src.bHidden;
	Dest.Sprite = Src.Sprite;
	Dest.Texture = Src.Texture;
	Dest.Skin = Src.Skin;
	Dest.Mesh = Src.Mesh;
	Dest.DrawScale = Src.DrawScale;
	Dest.ScaleGlow = Src.ScaleGlow;
	Dest.VisibilityRadius = Src.VisibilityRadius;
	Dest.VisibilityHeight = Src.VisibilityHeight;
	Dest.AmbientGlow = Src.AmbientGlow;
	Dest.Fatness = Src.Fatness;
	Dest.SpriteProjForward = Src.SpriteProjForward;
	Dest.bUnlit = Src.bUnlit;
	Dest.bNoSmooth = Src.bNoSmooth;
	Dest.bParticles = Src.bParticles;
	Dest.bRandomFrame = Src.bRandomFrame;
	Dest.bMeshEnviroMap = Src.bMeshEnviroMap;
	Dest.bMeshCurvy = Src.bMeshCurvy;
	Dest.bFilterByVolume = Src.bFilterByVolume;
	Dest.SetCollision(Src.bCollideActors, Src.bBlockActors, Src.bBlockPlayers);
	//Dest.bCollideActors	= Src.bCollideActors;
	//Dest.bBlockActors		= Src.bBlockActors;
	//Dest.bBlockPlayers		= Src.bBlockPlayers;
	Dest.bCollideWorld		= Src.bCollideWorld;
	Dest.bProjTarget		= Src.bProjTarget;
	Dest.SetCollisionSize(Src.CollisionRadius, Src.CollisionHeight);

	Dest.SoundRadius	= Src.SoundRadius;
	Dest.SoundVolume	= Src.SoundVolume;
	Dest.SoundPitch	= Src.SoundPitch;

	Dest.TransientSoundVolume = Src.TransientSoundVolume;
	Dest.TransientSoundRadius = Src.TransientSoundRadius;

	// if Physics is set here, Pawns react not normal on MoveTo()
	// if (Dest.bCollideWorld)
	//	Dest.SetPhysics(Src.Physics);

	return True;
}



static function bool CopyProperties_Pawn(Pawn Src, Pawn Dest, bool bCopyParentProperties) {
/******************************************************************************
Returns TRUE if properties were copied successfully, FALSE otherwise.
******************************************************************************/
	if (bCopyParentProperties)
		if ( ! CopyProperties_Actor(Src, Dest))
			return False;

	Dest.bCanStrafe = Src.bCanStrafe;
	Dest.bFixedStart = Src.bFixedStart;
	Dest.MeleeRange = Src.MeleeRange;

	Dest.GroundSpeed = Src.GroundSpeed;
	Dest.WaterSpeed = Src.WaterSpeed;
	Dest.AirSpeed = Src.AirSpeed;
	Dest.AccelRate = Src.AccelRate;
	Dest.JumpZ = Src.JumpZ;
	Dest.MaxStepHeight = Src.MaxStepHeight;
	Dest.AirControl = Src.AirControl;
	Dest.Visibility = Src.Visibility;

	Dest.SightRadius = Src.SightRadius;
	Dest.PeripheralVision = Src.PeripheralVision;
	Dest.HearingThreshold = Src.HearingThreshold;
	Dest.BaseEyeHeight = Src.BaseEyeHeight;
	Dest.FovAngle = Src.FovAngle;
	Dest.Health = Src.Health;
	Dest.SelectionMesh = Src.SelectionMesh;
	Dest.SpecialMesh = Src.SpecialMesh;
	Dest.ReducedDamageType = Src.ReducedDamageType;
	Dest.ReducedDamagePct = Src.ReducedDamagePct;
	Dest.DropWhenKilled = Src.DropWhenKilled;
	Dest.UnderWaterTime = Src.UnderWaterTime;
	Dest.AttitudeToPlayer = Src.AttitudeToPlayer;
	Dest.Intelligence = Src.Intelligence;
	Dest.Skill = Src.Skill;
	Dest.HitSound1 = Src.HitSound1;
	Dest.HitSound2 = Src.HitSound2;
	Dest.Land = Src.Land;
	Dest.Die = Src.Die;
	Dest.WaterStep = Src.WaterStep;
	Dest.CombatStyle = Src.CombatStyle;
	Dest.AlarmTag = Src.AlarmTag;
	Dest.SharedAlarmTag = Src.SharedAlarmTag;
	Dest.MenuName = Src.MenuName;
	Dest.NameArticle = Src.NameArticle;
	Dest.VoicePitch = Src.VoicePitch;
	Dest.VoiceType = Src.VoiceType;
	Dest.PlayerReplicationInfoClass = Src.PlayerReplicationInfoClass;

	return True;
}



static function bool CopyProperties_Queen(Queen Src, Queen Dest, bool bCopyParentProperties) {
	if (bCopyParentProperties)
		if ( ! CopyProperties_ScriptedPawn(Src, Dest, true))
			return False;


	Dest.ClawDamage = Src.ClawDamage;
	Dest.StabDamage = Src.StabDamage;
	Dest.ScreamEvent = Src.ScreamEvent;
	Dest.footstepSound = Src.footstepSound;
	Dest.ScreamSound = Src.ScreamSound;
	Dest.stab = Src.stab;
	Dest.shoot = Src.shoot;
	Dest.claw = Src.claw;

	return True;
}



static function bool CopyProperties_ScriptedPawn(ScriptedPawn Src, ScriptedPawn Dest, bool bCopyParentProperties) {
/******************************************************************************
Returns TRUE if properties were copied successfully, FALSE otherwise.
******************************************************************************/

	if (bCopyParentProperties)
		if ( ! CopyProperties_Pawn(Src, Dest, bCopyParentProperties))
			return False;

	Dest.CarcassType = Src.CarcassType;
	Dest.TeamTag = Src.TeamTag;
	//Dest.TeamLeader = Src.TeamLeader;
	//Dest.Team = Src.Team;
	//Dest.TeamID = Src.TeamID;
	Dest.Orders = Src.Orders;
	Dest.OrderTag = Src.OrderTag;
	Dest.TimeBetweenAttacks = Src.TimeBetweenAttacks;
	Dest.Aggressiveness = Src.Aggressiveness;
	Dest.ReFireRate = Src.ReFireRate;
	//Dest.WalkingSpeed = Src.WalkingSpeed;
	Dest.FirstHatePlayerEvent = Src.FirstHatePlayerEvent;
	Dest.bHasRangedAttack = Src.bHasRangedAttack;
	Dest.bMovingRangedAttack = Src.bMovingRangedAttack;
	Dest.bQuiet = Src.bQuiet;
	Dest.bTeamLeader = Src.bTeamLeader;
	Dest.bIgnoreFriends = Src.bIgnoreFriends;
	Dest.bHateWhenTriggered = Src.bHateWhenTriggered;
	Dest.bDelayedPatrol = Src.bDelayedPatrol;
	Dest.bIsWuss = Src.bIsWuss;
	Dest.bLeadTarget = Src.bLeadTarget;
	Dest.bWarnTarget = Src.bWarnTarget;
	Dest.bIsBoss = Src.bIsBoss;
	Dest.bNoWait = Src.bNoWait;
	Dest.RangedProjectile = Src.RangedProjectile;
	Dest.ProjectileSpeed = Src.ProjectileSpeed;
	Dest.Acquire = Src.Acquire;
	Dest.Fear = Src.Fear;
	Dest.Roam = Src.Roam;
	Dest.Threaten = Src.Threaten;
	return true;
}



static function string GetTimeStampStr(Levelinfo Level) {
/******************************************************************************
Returns a formatted time string YYYY-MM-DD hh:mm:ss
******************************************************************************/
	return Level.Year $ "-" $ TwoDigitString(Level.Month) $ "-"
		$ TwoDigitString(Level.Day) $ " " $ TwoDigitString(Level.Hour) $ ":"
		$ TwoDigitString(Level.Minute) $ ":" $ TwoDigitString(Level.Second);
}



static function LogEx(Actor Caller, bool bUseTimeStamp, string FunctionName, string msg) {
/*******************************************************************************
Adds Caller's name and *FunctionName* in front of every log entry *msg*. If
*bUseTimeStamp* is set, a TimeStamp is also added in front.
*******************************************************************************/
local string TimeStampStr;

	if (Caller == None)
		warn("Caller == None");
	else
	{
		if (bUseTimeStamp) TimeStampStr = GetTimeStampStr(Caller.level) $ " ";
		Log(TimeStampStr $ Caller $ "." $ FunctionName $ ":" @ msg);
	}
}



static function bool PropertyHasValue(Actor A, coerce string PropertyName, coerce string ExpectedValue) {
/******************************************************************************
Returns TRUE if the property *PropertyName* of Actor *A* has *ExpectedValue*
******************************************************************************/
	if (A.GetPropertyText(PropertyName) != ExpectedValue)
	{
		warn(A $ "." $ PropertyName @ "should be" @ ExpectedValue $ ", but is" @ A.GetPropertyText(PropertyName));
		return false;
	}
	return true;
}



static function bool SetCollisionEx(Actor A, optional bool NewColActors, optional bool NewBlockActors, optional bool NewBlockPlayers) {
/******************************************************************************
Just an encapsulation for *SetCollision* with additional true/false returned.
******************************************************************************/
	A.SetCollision(NewColActors, NewBlockActors, NewBlockPlayers);

	if ( ! PropertyHasValue(A, "bCollideActors", NewColActors))
		return false;
	if ( ! PropertyHasValue(A, "bBlockActors", NewBlockActors))
		return false;
	if ( ! PropertyHasValue(A, "bBlockPlayers", NewBlockPlayers))
		return false;
	return true;
}



static function bool SetPropertyTextEx(Object obj, coerce string PropName, coerce string PropValue) {
/*******************************************************************************
Does the same as *SetPropertyText* but logs a warning if property could not be
set.
Returns TRUE if value was set successfully.
*******************************************************************************/
	Obj.SetPropertyText(PropName, PropValue);
	if (Obj.GetPropertyText(PropName) != PropValue)
	{
		warn(obj $ ".SetPropertyText(" $ PropName $ "=" $ PropValue $ ") failed for" @ obj $", current property value=\"" $ Obj.GetPropertyText(PropName) $ "\"");
		return false;
	}
	else
		return true;
}



static function string TwoDigitString(int Num) {
	if (Num >= 0 && Num < 10)
		return "0" $ string(Num);
	else
		return string(Num);
}

